/* programmed by fkz (1999) */
/* $Id: nise-fetch.c,v 1.2 1999/11/19 13:16:30 fkz Exp fkz $ */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#define TRUE 1
#define FALSE 0
#define DELIMITER "\r\n"
#define ALLOCSIZE 1024

/* definition of constant */
char *http_method="GET ";
char *url_prot="http://";
char *url_host="www.mediaworks.co.jp";
char *url_file="/cgi-bin/sis_read.cgi?dir=log&mode=request&page=";
char *http_version=" HTTP/1.0";

char *delimiter=DELIMITER;
char *UserAgent="Nise-fetchForSisterPrincessBBS/";
char *Version="19991121b";

/* definition of variable(s) */
char with_proxy=FALSE;
char *proxy_host=NULL;
char *host;
char *file;
long port=80; /* default HTTP port is 80 */
int numberarg=0;
int proxyarg=0;
int reportlevel=1;

extern int errno;

char *setproxy(char **dst,long *port,char *src){
  /* srcproxyhost.sub.domain[:proxy_port] ä
     dstproxyۥ̾portproxy_port򥻥åȤ */
  /* ԤNULL֤ */

  char *ptr=NULL;

  size_t size=0;
  size=sizeof(char) * (1 + strlen(src));
  *dst=(char *)malloc(size);
  if(*dst==NULL){
    fprintf(stderr,"setproxy: Can't allocate memory.\n");
    fflush(stderr);
  }else{
    strcpy(*dst,src);
    if((ptr = strstr(*dst,":")) != NULL){
      *ptr='\0';
      ptr+=1;
      *port=atol(ptr);
      if(*port < 0)
	*port=0;
    }
  }
  return(*dst);
}

char *nise_strcat(char *dst,char *src){
  /* dstǼʸθsrcҤ */
  /* reallocȤ餢ޤꤪᤸʤ */
  /* ԤNULL֤ */

  char *ptr=NULL;
  size_t size=0;

  if(dst!=NULL){
    size=sizeof(char) * (strlen(dst) + strlen(src) + 1);
  }else{
    size=sizeof(char) * (strlen(src) + 1);
  }
  ptr=realloc(dst,size);
  if(ptr == NULL){
    /* false */
    fprintf(stderr,"nise_strcat: Can't allocate memory.\n");
    fflush(stderr);
    free(dst);
  }else{
    if(dst==NULL){
      *ptr='\0';
    }
    strcat(ptr,src);
  }
  return(ptr);
}

char *stripbody(char *data){
  char *ptr;
  ptr = strstr(data, DELIMITER DELIMITER);
  ptr += strlen(DELIMITER DELIMITER);
  return(ptr);
}

int write_to_file(char *name,char *data,size_t datasize){
  /* nameȤե˥ǡ񤭽Ф */
  /* name=NULLξstdout˽񤭽Ф */
  FILE *stream;
  size_t offset=0;
  int terminate=FALSE;
  int c=0;
  char *body;

  if(datasize==0){
    return(0);
  }

  if(name != NULL){
    stream=fopen(name,"w");
    if(stream == NULL){
      terminate=TRUE;
      fprintf(stderr,"writefile: Can't open output file.\n");
      if(reportlevel > 5){
	fprintf(stderr,"filename: %s\n",name);
      }
      fflush(stderr);
    }
    /* success */
  }else{
    stream=stdout;
  }
  body=stripbody(data);

  while((c = *(body + offset++)) != '\0'){
    fputc(c,stream); 
  }

  if(stream != stdout){
    fflush(stream);
    fclose(stream);
  }
  return(terminate);
}

char *resize(char *buffer, size_t size){
  char *ptr=NULL;
  ptr=realloc(buffer,size + ALLOCSIZE);
  if(ptr == NULL){
     fprintf(stderr,"resize: Can't allocate memory.\n");
     if(reportlevel > 2)
       fprintf(stderr,"%s\n",size + ALLOCSIZE);
     fflush(stderr);
   }
  return(ptr);
}

void receivemonitor(size_t offset,size_t header_length,size_t content_length){
  int p=0;
  fprintf(stderr,"\rReceived: ");
  p=((offset - header_length)*100)/content_length;
  fprintf(stderr,"%d%%",p);
  fprintf(stderr," ( %ld bytes of %ld ) ",
	  offset - header_length, content_length);
  fflush(stderr);
}

void receivemonitor_b(size_t offset){
  fprintf(stderr,"\rReceived: (%ld)",offset);
  fflush(stderr);
}

char *receivedata(char *buffer,size_t *readsize,FILE *stream){
  int c=0;
  size_t size=0;
  size_t offset=0;
  char *ptr;
  int terminate=FALSE;
  int state=0;
  long content_length=0;
  long header_length=0;

  while((c = fgetc(stream)) != EOF){
    if(c=='\0')
      break;
    if((size == 0) || (offset > size - 3)){
      ptr=resize(buffer,size);
      if(ptr == NULL){
	terminate=TRUE;
	break;
      }else{
	buffer=ptr;
	size += ALLOCSIZE;
	if(state==0){
	  /* 512κ̵ */
	  if(offset > 512){
	    ptr=strstr(buffer,"Content-Length:");
	    if(ptr!=0){
	      ptr += strlen("Content-Length:");
	      content_length=atol(ptr);
	      state++;
	    }
	  }
	  receivemonitor_b(offset);
	}else if(state==1){
	  /* 1024κ̵ */
	  if(offset > 1024){
	    ptr=strstr(buffer,DELIMITER DELIMITER);
	    if(ptr!=0){
	      ptr += strlen(DELIMITER DELIMITER);
	      header_length=ptr - buffer;
	      state++;
	    }
	  }
	  receivemonitor_b(offset);
	}else{
	  /* state >= 2 */
	  if(reportlevel > 0){
	    receivemonitor(offset,header_length,content_length);
	  }
	}
      }
    }
    *(buffer + offset++)=c;
    *(buffer + offset)='\0';
  }
  if(reportlevel > 0){
    if(state>1){
      receivemonitor(offset,header_length,content_length);
      fprintf(stderr,"\n");
    }else{
      receivemonitor_b(offset);
      fprintf(stderr,"\n");
    }
  }
  if(terminate == TRUE){
    fprintf(stderr,"transfer terminated!\n");
  }
  fflush(stderr);
  *readsize=offset;
  return(buffer);
}

int sendrequest(int s,char *lognumber){
  char *message=NULL;
  char ctr=0;
  char **ptr_messages=NULL;
  char *messages_proxy[]={
    http_method,url_prot,url_host,url_file,lognumber,http_version,delimiter,NULL,
    "User-Agent: ",UserAgent,Version,delimiter,NULL,
    delimiter,delimiter,NULL,
    NULL };
  char *messages_direct[]={
    http_method,url_file,lognumber,http_version,delimiter,NULL,
    "User-Agent: ",UserAgent,Version,delimiter,NULL,
    delimiter,delimiter,NULL,
    NULL };
  int terminate=FALSE;

  if(with_proxy==TRUE){
    ptr_messages=messages_proxy;
  }else{
    ptr_messages=messages_direct;
  }
  ctr=0;
  while( ptr_messages[ctr] != NULL){
    message=NULL;
    while( ptr_messages[ctr] != NULL ){
/*
   #ifdef DEBUG
   fprintf(stderr,"[%d:%s]",ctr,ptr_messages[ctr]);
   fflush(stderr);
   #endif
*/
      if((message=nise_strcat(message,ptr_messages[ctr++])) ==NULL){
	terminate=TRUE;
	break;
      }
    }
    if(terminate==TRUE)
      break;
    if(reportlevel > 9){
      fprintf(stderr,"%s",message);
      fflush(stderr);
    }
    send(s,message,strlen(message), 0);
    free(message);
    ctr++;
  }
  return(terminate);
}

void usage(){
  printf("Usage: nise-fetch [-hv] [-p proxy_host[:port]] [-r level] lognumber\n");
  printf("\t-p: use HTTP PROXY server. default port is 80.\n");
  printf("\t-r: set reportlevel as level.\n");
  printf("\t-f: set PREFIX of output file.(Not implemented.)\n");
  printf("\t-v: show version.\n");
  printf("\t-h: show help.(this text)\n");
  return;
}

int optset(int argc,char *argv[]){
  int optcounter = 1;
  char d=0;
  int terminate=FALSE;

  while(optcounter < argc){
    if(*argv[optcounter] == '-'){
      d=*(argv[optcounter] + 1);
      switch(d){
      case'p':
	if(optcounter + 1 < argc){
	  proxyarg=optcounter+1;
	  optcounter++;
	}else{
	  terminate=TRUE;
	  fprintf(stderr,"-p option needs a hostname[:port]\n");
	  fflush(stderr);
	}
	break;
      case'v':
	fprintf(stderr,"Version: %s\n",Version);
	terminate=TRUE;
	break;
      case'h':
	usage();
	terminate=TRUE;
	break;
      case'r':
	if(optcounter + 1 < argc){
	  reportlevel=atoi(argv[optcounter + 1]);
	  optcounter++;
	}else{
	  terminate=TRUE;
	  fprintf(stderr,"-r option needs an operator of integer.\n");
	  fflush(stderr);
	}
      }
    }else{
      numberarg=optcounter;
    }
    if(terminate==TRUE)
      break;
    optcounter++;
  }
  return(terminate);
}

int main(int argc,char *argv[]){
  int terminate=FALSE;
  char *ptr=NULL;
  char *buffer=NULL;
  size_t readsize=0;
  register int s;
  struct hostent *hp;
  struct sockaddr_in sin;
  FILE *stream;
  char *output_name;

/* init */
  terminate=optset(argc,argv);
  if(terminate == TRUE){
    return(0);
  }
  if(numberarg==0){
    terminate=TRUE;
    fprintf(stderr,"require log number.\n");
    return(1);
  }
  if((ptr=getenv("HTTP_PROXY")) != NULL){
    proxy_host=ptr;
  }
  if(proxyarg != 0){
    proxy_host=argv[proxyarg];
  }
  if(proxy_host != NULL){
    with_proxy=TRUE;
    if(setproxy(&host,&port,proxy_host) == NULL){
      fprintf(stderr,"main: Iligal proxy. (%s)\n",proxy_host);
      fflush(stderr);
      return(1);
    }
  }else{
    with_proxy=FALSE;
    host=url_host;
  }

  output_name=NULL;
  if((output_name=nise_strcat(output_name,argv[numberarg]))!=NULL){
    output_name=nise_strcat(output_name,".html");
    if(output_name==NULL){
      exit(1);
    }
  }

/* dnslookup */
  if(reportlevel > 3){
    fprintf(stderr,"Looking up [%s]\n",host);
    fflush(stderr);
  }
  if((hp = gethostbyname( host )) == NULL){
    fprintf(stderr,"unknown host. (%s)\n",host);
    fflush(stderr);
    free(host);
    exit(1);
  }

/* open connection */
  if(reportlevel > 3){
    fprintf(stderr,"connecting.\n");
    fflush(stderr);
  }
  if((s = socket(AF_INET,SOCK_STREAM, 0)) < 0){
    fprintf(stderr,"socket failure.\n");
    fflush(stderr);
    exit(1);
  }

/* connected */
  sin.sin_family = PF_INET;
  sin.sin_port = htons( port );
  memcpy(&sin.sin_addr,hp->h_addr,hp->h_length);
  if(connect(s, (struct sockaddr *)&sin, sizeof(sin)) < 0){
    perror("main: can not connect.");
    exit(1);
  }
  stream=fdopen(s,"r");
  if(stream == NULL){
    fprintf(stderr,"Can not connect.\n");
    fflush(stderr);
    exit(1);
  }

/* send request */
  if(reportlevel > 5){
    fprintf(stderr,"sending request.\n");
    fflush(stderr);
  }
  sendrequest(s,argv[numberarg]);

/* load data */
  buffer=receivedata(buffer,&readsize,stream);

/* close connection */
  close(s);
  if(reportlevel > 3){
    fprintf(stderr,"connection closed.\n");
    fflush(stderr);
  }

/* write data */
  write_to_file( output_name, buffer,readsize);

/* close */
  if(buffer!=NULL)
    free(buffer);
  if(output_name!=NULL)
    free(output_name);
  if(with_proxy==TRUE)
    free(host);

  return(0);
}

